#ifndef	_ATLANTIS_H
#define	_ATLANTIS_H

/*
	Main module
*/

int	AddIn_main(int isAppli, unsigned short OptionNum);

/*
	Display module
*/

#define	MODE_AND	0
#define	MODE_OR		1
#define	MODE_XOR	2

void	dinit(void);
void	dpixel(int x, int y, int color);
int	dget(int x, int y);
void	dclear(void);
void	dbitmap(const unsigned char *bitmap, int x, int y, int width,
	int height, int mode);

/*
	Main menu

	main_menu()
	Returns 0 when starting a new game, or 1 when continuing.
*/

int	main_menu(void);

/*
	World map

	world_map()
	Enter the world map. Returns when the player selects a level to play.
*/

int	world_map(void);

/*
	Level

	Core of the gameplay.
*/

void	level_enter(int place);

/*
	Save module

	load()
	Creates a new save file in main memory if none exists, and loads it.
	Returns a status code: 0 when loading worked, 1 otherwise.

	save()
	Saves the current data to the main memory.
*/

struct SaveData
{
	int chapter;
	int level;

	int turn_moves;
	int turn_attacks;

	int life;
	int atk, def;
};

extern struct SaveData data;

int	load(void);
void	save(void);

/*
	Macros.
*/

#define	abs(x)		((x) < 0 ? -(x) : (x))
#define	len(a, b, x, y)	(abs((a) - (x)) + abs((b) - (y)))

#endif	// _ATLANTIS_H
