// Thanks to Simon Lothar for syscall 0x0135.
typedef char * (*sc_cpv)(void);
const unsigned int sc0135[] = {
	0xD201D002,
	0x422B0009,
	0x80010070,
	0x0135
};
#define dvram (*(sc_cpv)sc0135)
char *vram;

void dinit(void)
{
	sc0135+1;
	vram = dvram();
}

void dpixel(int x, int y, int c)
{
	if(x & ~127 || y & ~63) return;
	if(c)	*(vram + (y << 4) + (x >> 3)) |=  (128 >> (x & 7));
	else	*(vram + (y << 4) + (x >> 3)) &= ~(128 >> (x & 7));
}

int dget(int x, int y)
{
	return (*(vram + (y << 4) + (x >> 3)) >> (~x & 7)) & 1;
}

void dclear(void)
{
	int i = 0;
	while(i < 1024) *(vram + i++) = 0;
}

void dbitmap(const unsigned char *bitmap, int x, int y, int w, int h, int m)
{
	unsigned char v;
	int i, j;

	for(i = 0; i < h; i++) for(j = 0; j < w; j++)
	{
		v = (*(bitmap + i * (((w - 1) >> 3) + 1) + (j >> 3)) >> (~j & 7)) & 1;

		switch(m)
		{
		case 0:
			if(!v)	dpixel(x + j, y + i, 0);
			break;
		case 1:
			if(v)	dpixel(x + j, y + i, 1);
			break;
		case 2:
			if(v)	dpixel(x + j, y + i, !dget(x + j, y + i));
			break;
		}
	}
}
